# Bootstrap percentile conf int

percentile.conf.length <- function(n, B, rdist,...)
{
	alpha <- 0.05
	x <- rdist(n,...)
	bootstrap.median <- replicate(B, median(sample( x, replace = "TRUE")))
	conf.upper <- sort(bootstrap.median)[floor(B*(1-alpha/2))]
	conf.lower <- sort(bootstrap.median)[floor((B*alpha/2))]
	conf.length <- conf.upper - conf.lower
	conf.length
}

Nseq <- c(11,21,51,101,501,1001)

conf.length.sequence.norm <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = rnorm))
conf.length.sequence.unif <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = runif))
conf.length.sequence.exp <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = rexp))
conf.length.sequence.lnorm <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = rlnorm))
conf.length.sequence.t <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = rt,5))
conf.length.sequence.chisq <- sapply(Nseq, function(n) percentile.conf.length(n, B = 500, rdist = rchisq,5))

# Coverage probability


cov.prob <- function(n, B, s, rdist, qdist,...)
{
	alpha <- 0.05
	median.pop <- qdist( 0.5,...)
	m1 = m2 = rep( 0, s) 	
	for ( l in 1 : s){
	x <- rdist(n,...)
	m1[l] <- sort(replicate(B, median(sample( x, replace = "TRUE"))))[floor(B*(alpha/2))] 
	m2[l] <- sort(replicate(B, median(sample( x, replace = "TRUE"))))[floor(B*(1-alpha/2))] 
	} 
	1- sum(median.pop < m1 | median.pop > m2)/s
}

cov.prob.norm <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = rnorm, qdist = qnorm) )
cov.prob.unif <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = runif, qdist = qunif) )
cov.prob.exp <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = rexp, qdist = qexp) )
cov.prob.lnorm <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = rlnorm, qdist = qlnorm) )
cov.prob.t <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = rt, qdist = qt, 5) )
cov.prob.chisq <- sapply(Nseq, function(n) cov.prob(n, B = 500, s = 10000, rdist = rchisq, qdist = qchisq, 5) )
























