# Bootstrap t conf int 

bootstrap.t.conf.length <- function(n, B, rdist, ...)
{
	alpha <- 0.05
	x <- rdist(n,...)
	bootstrap.sample <- replicate(B, sample( x, replace= "TRUE"))
	bootstrap.median <- rep(0, B)
	for ( l in 1 : B){
	bootstrap.median[l] = median(bootstrap.sample[,l])
	}
	i <- 1:n 
	k <- (n + 1)/2 
	p.i <- pbinom( k, n, (i-1)/n) - pbinom( k, n, i/n)
	plugin.est <- median(x)
	var <- rep(0, B)
	for ( l in 1: B)
	{
		var[l] <- sum(sort(bootstrap.sample[,l])^2*p.i)-(sum(sort(bootstrap.sample[,l])*p.i))^2
	}
	z <- rep(0,B)
	for ( l in 1 : B)
	{
		z[l] = (bootstrap.median[l] - plugin.est)/sqrt(var[l])
	}
	v <- sum(sort(x)^2*p.i)-(sum(sort(x)*p.i))^2
	conf.upper <- plugin.est - sqrt(v)*(sort(z)[floor(B*(alpha/2))])
	conf.lower <- plugin.est - sqrt(v)*(sort(z)[floor(B*(1-alpha/2))])
	conf.length <- conf.upper- conf.lower
	conf.length 
}
Nseq <- c(11,21,51,101,501,1001)
conf.length.sequence.norm <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = rnorm))
conf.length.sequence.unif <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = runif))
conf.length.sequence.exp <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = rexp))
conf.length.sequence.lnorm <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = rlnorm))
conf.length.sequence.t <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = rt, 5))
conf.length.sequence.chisq <- sapply(Nseq, function(n) bootstrap.t.conf.length(n, B = 2500, rdist = rchisq, 5))



# coverage probability

cov.prob <- function(n, B, s, rdist, qdist,...)
{
	population.median <- qdist( 0.5, ...)
	m1 = m2 = rep(0,s)
	for ( a in 1 : s)
	{
		alpha <- 0.05
		x <- rdist(n,...)
		bootstrap.sample <- replicate(B, sample( x, replace= "TRUE"))
		bootstrap.median <- rep(0, B)
		for ( l in 1 : B){
		bootstrap.median[l] = median(bootstrap.sample[,l])
		}
		i <- 1:n 
		k <- (n + 1)/2 
		p.i <- pbinom( k, n, (i-1)/n) - pbinom( k, n, i/n)
		plugin.est <- median(x)
		var <- rep(0, B)
		for ( l in 1: B)
		{
			var[l] <- sum(sort(bootstrap.sample[,l])^2*p.i)-(sum(sort(bootstrap.sample[,l])*p.i))^2
		}
		z <- rep(0,B)
		for ( l in 1 : B)
		{
			z[l] = (bootstrap.median[l] - plugin.est)/sqrt(var[l])
		}
		v <- sum(sort(x)^2*p.i)-(sum(sort(x)*p.i))^2
		m2[a] <- plugin.est + sqrt(v)*(sort(z)[floor(B*(1-alpha/2))])
		m1[a] <- plugin.est + sqrt(v)*(sort(z)[floor(B*alpha/2)])
	}
	1 - sum( population.median < m1 | population.median > m2)/s 
}

cov.prob.norm <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = rnorm, qdist =qnorm))
cov.prob.unif <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = unif, qdist =qunif))
cov.prob.exp <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = rexp, qdist =qexp))
cov.prob.lnorm <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = rlnorm, qdist =qlnorm))
cov.prob.t <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = rt, qdist =qt, 5))
cov.prob.chisq <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s=1000, rdist = rchisq, qdist =qchisq, 5))

 


