
# Asymtotic normal approximation

conf.length <- function(n, B, rdist, ddist, qdist, ...){
alpha <- 0.05
x <- rdist(n,...)
median.sample <- median(x)
var.median.population <- var(replicate(B, median(sample(x, replace = TRUE))))
conf.lower <- median.sample - sqrt(var.median.population)*qnorm(1-alpha/2)
conf.upper <- median.sample + sqrt(var.median.population)*qnorm(1-alpha/2)  
conf.length <- conf.upper - conf.lower
conf.length
}

Nseq <- c(11,21,51,101,501,1001)

seq.conf.length.norm <- sapply(Nseq, function(n) conf.length(n, rdist = rnorm, ddist = dnorm, qdist= qnorm))
seq.conf.length.unif <- sapply(Nseq, function(n) conf.length(n, rdist = runif, ddist = dunif, qdist= qunif))
seq.conf.length.exp <- sapply(Nseq, function(n) conf.length(n, rdist = rexp, ddist = dexp, qdist= qexp))
seq.conf.length.lnorm <- sapply(Nseq, function(n) conf.length(n, rdist = rlnorm, ddist = dlnorm, qdist= qlnorm))
seq.conf.length.t <- sapply(Nseq, function(n) conf.length(n, rdist = rt, ddist = dt, qdist= qt, 5))
seq.conf.length.chisq <- sapply(Nseq, function(n) conf.length(n, rdist = rchisq, ddist = dchisq, qdist= qchisq, 5))


cov.prob <- function(n, B, s, rdist, qdist, ddist, ...)
{
	alpha <- 0.05
	median.pop <- qdist( 0.5,...)
	m1 = m2 = rep( 0, s) 	
	for ( l in 1 : s){
	x <- rdist(n,...)
	m1[l] <- median(x) - sqrt(var(replicate(B, median(sample(x, replace = TRUE))))
	)*qnorm(1-alpha/2)
	m2[l] <- median(x) + sqrt(var(replicate(B, median(sample(x, replace = TRUE))))
	)*qnorm(1-alpha/2)
	} 
	1- sum(median.pop < m1 | median.pop > m2)/s
}



cov.prob.norm <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s = 10000, rdist = rnorm, qdist = qnorm, ddist = dnorm) )
cov.prob.unif <- sapply(Nseq, function(n) cov.prob(n, B=2500, s = 10000, rdist = runif, qdist = qunif, ddist = dunif) )
cov.prob.exp <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s = 10000, rdist = rexp, qdist = qexp, ddist = dexp) )
cov.prob.lnorm <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s = 10000, rdist = rlnorm, qdist = qlnorm, ddist = dlnorm) )
cov.prob.t <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s = 10000, rdist = rt, qdist = qt, ddist = dt, 5) )
cov.prob.chisq <- sapply(Nseq, function(n) cov.prob(n, B = 2500, s = 10000, rdist = rchisq, qdist = qchisq, ddist = dchisq, 5) )






 

